{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 10.0 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddmariadb100;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB100DDEngine }

  TSQLDBMariaDB100DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB100DDEngine;
Procedure UnRegisterMariaDB100DDEngine;

implementation

uses mariadb100conn;

Procedure RegisterMariaDB100DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB100DDEngine);
end;

Procedure UnRegisterMariaDB100DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB100DDEngine);
end;

{ TSQLDBMariaDB100DDEngine }

function TSQLDBMariaDB100DDEngine.CreateConnection(AConnectString: String
  ): TSQLConnection;
begin
  Result:=MariaDB100conn.TMariaDB100Connection.Create(Self);
end;

class function TSQLDBMariaDB100DDEngine.Description: string;
begin
  Result:='MariaDB 10.0 connection using SQLDB';
end;

class function TSQLDBMariaDB100DDEngine.DBType: String;
begin
  Result:='MariaDB 10.0';
end;

end.

