{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 10.10 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddmariadb1010;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB1010DDEngine }

  TSQLDBMariaDB1010DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB1010DDEngine;
Procedure UnRegisterMariaDB1010DDEngine;

implementation

uses MariaDB1010conn;

Procedure RegisterMariaDB1010DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB1010DDEngine);
end;

Procedure UnRegisterMariaDB1010DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB1010DDEngine);
end;

{ TSQLDBMariaDB1010DDEngine }

function TSQLDBMariaDB1010DDEngine.CreateConnection(AConnectString: String): TSQLConnection;
begin
  Result:=MariaDB1010conn.TMariaDB1010Connection.Create(Self);
end;

class function TSQLDBMariaDB1010DDEngine.Description: string;
begin
  Result:='MariaDB 10.10 connection using SQLDB';
end;

class function TSQLDBMariaDB1010DDEngine.DBType: String;
begin
  Result:='MariaDB 10.10';
end;

end.

