{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 10.11 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddmariadb1011;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB1011DDEngine }

  TSQLDBMariaDB1011DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB1011DDEngine;
Procedure UnRegisterMariaDB1011DDEngine;

implementation

uses MariaDB1011conn;

Procedure RegisterMariaDB1011DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB1011DDEngine);
end;

Procedure UnRegisterMariaDB1011DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB1011DDEngine);
end;

{ TSQLDBMariaDB1011DDEngine }

function TSQLDBMariaDB1011DDEngine.CreateConnection(AConnectString: String): TSQLConnection;
begin
  Result:=MariaDB1011conn.TMariaDB1011Connection.Create(Self);
end;

class function TSQLDBMariaDB1011DDEngine.Description: string;
begin
  Result:='MariaDB 10.11 connection using SQLDB';
end;

class function TSQLDBMariaDB1011DDEngine.DBType: String;
begin
  Result:='MariaDB 10.11';
end;

end.

