{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 10.2 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddmariadb102;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB102DDEngine }

  TSQLDBMariaDB102DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB102DDEngine;
Procedure UnRegisterMariaDB102DDEngine;

implementation

uses mariadb102conn;

Procedure RegisterMariaDB102DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB102DDEngine);
end;

Procedure UnRegisterMariaDB102DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB102DDEngine);
end;

{ TSQLDBMariaDB102DDEngine }

function TSQLDBMariaDB102DDEngine.CreateConnection(AConnectString: String
  ): TSQLConnection;
begin
  Result:=MariaDB102conn.TMariaDB102Connection.Create(Self);
end;

class function TSQLDBMariaDB102DDEngine.Description: string;
begin
  Result:='MariaDB 10.2 connection using SQLDB';
end;

class function TSQLDBMariaDB102DDEngine.DBType: String;
begin
  Result:='MariaDB 10.2';
end;

end.

