{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 10.4 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddmariadb104;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB104DDEngine }

  TSQLDBMariaDB104DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB104DDEngine;
Procedure UnRegisterMariaDB104DDEngine;

implementation

uses mariadb104conn;

Procedure RegisterMariaDB104DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB104DDEngine);
end;

Procedure UnRegisterMariaDB104DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB104DDEngine);
end;

{ TSQLDBMariaDB104DDEngine }

function TSQLDBMariaDB104DDEngine.CreateConnection(AConnectString: String): TSQLConnection;
begin
  Result:=MariaDB104conn.TMariaDB104Connection.Create(Self);
end;

class function TSQLDBMariaDB104DDEngine.Description: string;
begin
  Result:='MariaDB 10.4 connection using SQLDB';
end;

class function TSQLDBMariaDB104DDEngine.DBType: String;
begin
  Result:='MariaDB 10.4';
end;

end.

