{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 10.5 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddmariadb105;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB105DDEngine }

  TSQLDBMariaDB105DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB105DDEngine;
Procedure UnRegisterMariaDB105DDEngine;

implementation

uses mariaDB105conn;

Procedure RegisterMariaDB105DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB105DDEngine);
end;

Procedure UnRegisterMariaDB105DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB105DDEngine);
end;

{ TSQLDBMariaDB105DDEngine }

function TSQLDBMariaDB105DDEngine.CreateConnection(AConnectString: String): TSQLConnection;
begin
  Result:=MariaDB105conn.TMariaDB105Connection.Create(Self);
end;

class function TSQLDBMariaDB105DDEngine.Description: string;
begin
  Result:='MariaDB 10.5 connection using SQLDB';
end;

class function TSQLDBMariaDB105DDEngine.DBType: String;
begin
  Result:='MariaDB 10.5';
end;

end.

