{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 10.6 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddmariadb106;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB106DDEngine }

  TSQLDBMariaDB106DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB106DDEngine;
Procedure UnRegisterMariaDB106DDEngine;

implementation

uses mariaDB106conn;

Procedure RegisterMariaDB106DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB106DDEngine);
end;

Procedure UnRegisterMariaDB106DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB106DDEngine);
end;

{ TSQLDBMariaDB106DDEngine }

function TSQLDBMariaDB106DDEngine.CreateConnection(AConnectString: String): TSQLConnection;
begin
  Result:=MariaDB106conn.TMariaDB106Connection.Create(Self);
end;

class function TSQLDBMariaDB106DDEngine.Description: string;
begin
  Result:='MariaDB 10.6 connection using SQLDB';
end;

class function TSQLDBMariaDB106DDEngine.DBType: String;
begin
  Result:='MariaDB 10.6';
end;

end.

