{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 10.7 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddmariadb107;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB107DDEngine }

  TSQLDBMariaDB107DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB107DDEngine;
Procedure UnRegisterMariaDB107DDEngine;

implementation

uses mariaDB107conn;

Procedure RegisterMariaDB107DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB107DDEngine);
end;

Procedure UnRegisterMariaDB107DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB107DDEngine);
end;

{ TSQLDBMariaDB107DDEngine }

function TSQLDBMariaDB107DDEngine.CreateConnection(AConnectString: String): TSQLConnection;
begin
  Result:=MariaDB107conn.TMariaDB107Connection.Create(Self);
end;

class function TSQLDBMariaDB107DDEngine.Description: string;
begin
  Result:='MariaDB 10.7 connection using SQLDB';
end;

class function TSQLDBMariaDB107DDEngine.DBType: String;
begin
  Result:='MariaDB 10.7';
end;

end.

