{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 10.8 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddmariadb108;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB108DDEngine }

  TSQLDBMariaDB108DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB108DDEngine;
Procedure UnRegisterMariaDB108DDEngine;

implementation

uses mariaDB108conn;

Procedure RegisterMariaDB108DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB108DDEngine);
end;

Procedure UnRegisterMariaDB108DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB108DDEngine);
end;

{ TSQLDBMariaDB108DDEngine }

function TSQLDBMariaDB108DDEngine.CreateConnection(AConnectString: String): TSQLConnection;
begin
  Result:=MariaDB108conn.TMariaDB108Connection.Create(Self);
end;

class function TSQLDBMariaDB108DDEngine.Description: string;
begin
  Result:='MariaDB 10.8 connection using SQLDB';
end;

class function TSQLDBMariaDB108DDEngine.DBType: String;
begin
  Result:='MariaDB 10.8';
end;

end.

