{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 10.9 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddmariadb109;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB109DDEngine }

  TSQLDBMariaDB109DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB109DDEngine;
Procedure UnRegisterMariaDB109DDEngine;

implementation

uses mariaDB109conn;

Procedure RegisterMariaDB109DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB109DDEngine);
end;

Procedure UnRegisterMariaDB109DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB109DDEngine);
end;

{ TSQLDBMariaDB109DDEngine }

function TSQLDBMariaDB109DDEngine.CreateConnection(AConnectString: String): TSQLConnection;
begin
  Result:=MariaDB109conn.TMariaDB109Connection.Create(Self);
end;

class function TSQLDBMariaDB109DDEngine.Description: string;
begin
  Result:='MariaDB 10.9 connection using SQLDB';
end;

class function TSQLDBMariaDB109DDEngine.DBType: String;
begin
  Result:='MariaDB 10.9';
end;

end.

