{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 11.00 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddmariadb1100;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB1100DDEngine }

  TSQLDBMariaDB1100DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB1100DDEngine;
Procedure UnRegisterMariaDB1100DDEngine;

implementation

uses MariaDB1100conn;

Procedure RegisterMariaDB1100DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB1100DDEngine);
end;

Procedure UnRegisterMariaDB1100DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB1100DDEngine);
end;

{ TSQLDBMariaDB1100DDEngine }

function TSQLDBMariaDB1100DDEngine.CreateConnection(AConnectString: String): TSQLConnection;
begin
  Result:=MariaDB1100conn.TMariaDB1100Connection.Create(Self);
end;

class function TSQLDBMariaDB1100DDEngine.Description: string;
begin
  Result:='MariaDB 11.00 connection using SQLDB';
end;

class function TSQLDBMariaDB1100DDEngine.DBType: String;
begin
  Result:='MariaDB 11.00';
end;

end.

