{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 11.01 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddmariadb1101;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB1101DDEngine }

  TSQLDBMariaDB1101DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB1101DDEngine;
Procedure UnRegisterMariaDB1101DDEngine;

implementation

uses MariaDB1101conn;

Procedure RegisterMariaDB1101DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB1101DDEngine);
end;

Procedure UnRegisterMariaDB1101DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB1101DDEngine);
end;

{ TSQLDBMariaDB1101DDEngine }

function TSQLDBMariaDB1101DDEngine.CreateConnection(AConnectString: String): TSQLConnection;
begin
  Result:=MariaDB1101conn.TMariaDB1101Connection.Create(Self);
end;

class function TSQLDBMariaDB1101DDEngine.Description: string;
begin
  Result:='MariaDB 11.01 connection using SQLDB';
end;

class function TSQLDBMariaDB1101DDEngine.DBType: String;
begin
  Result:='MariaDB 11.01';
end;

end.

