{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 11.02 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddmariadb1102;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB1102DDEngine }

  TSQLDBMariaDB1102DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB1102DDEngine;
Procedure UnRegisterMariaDB1102DDEngine;

implementation

uses MariaDB1102conn;

Procedure RegisterMariaDB1102DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB1102DDEngine);
end;

Procedure UnRegisterMariaDB1102DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB1102DDEngine);
end;

{ TSQLDBMariaDB1102DDEngine }

function TSQLDBMariaDB1102DDEngine.CreateConnection(AConnectString: String): TSQLConnection;
begin
  Result:=MariaDB1102conn.TMariaDB1102Connection.Create(Self);
end;

class function TSQLDBMariaDB1102DDEngine.Description: string;
begin
  Result:='MariaDB 11.02 connection using SQLDB';
end;

class function TSQLDBMariaDB1102DDEngine.DBType: String;
begin
  Result:='MariaDB 11.02';
end;

end.

