{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 11.03 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddmariadb1103;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB1103DDEngine }

  TSQLDBMariaDB1103DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB1103DDEngine;
Procedure UnRegisterMariaDB1103DDEngine;

implementation

uses MariaDB1103conn;

Procedure RegisterMariaDB1103DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB1103DDEngine);
end;

Procedure UnRegisterMariaDB1103DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB1103DDEngine);
end;

{ TSQLDBMariaDB1103DDEngine }

function TSQLDBMariaDB1103DDEngine.CreateConnection(AConnectString: String): TSQLConnection;
begin
  Result:=MariaDB1103conn.TMariaDB1103Connection.Create(Self);
end;

class function TSQLDBMariaDB1103DDEngine.Description: string;
begin
  Result:='MariaDB 11.03 connection using SQLDB';
end;

class function TSQLDBMariaDB1103DDEngine.DBType: String;
begin
  Result:='MariaDB 11.03';
end;

end.

