{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 11.04 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddmariadb1104;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB1104DDEngine }

  TSQLDBMariaDB1104DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB1104DDEngine;
Procedure UnRegisterMariaDB1104DDEngine;

implementation

uses MariaDB1104conn;

Procedure RegisterMariaDB1104DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB1104DDEngine);
end;

Procedure UnRegisterMariaDB1104DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB1104DDEngine);
end;

{ TSQLDBMariaDB1104DDEngine }

function TSQLDBMariaDB1104DDEngine.CreateConnection(AConnectString: String): TSQLConnection;
begin
  Result:=MariaDB1104conn.TMariaDB1104Connection.Create(Self);
end;

class function TSQLDBMariaDB1104DDEngine.Description: string;
begin
  Result:='MariaDB 11.04 connection using SQLDB';
end;

class function TSQLDBMariaDB1104DDEngine.DBType: String;
begin
  Result:='MariaDB 11.04';
end;

end.

