{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 11.06 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddMariaDB1106;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB1106DDEngine }

  TSQLDBMariaDB1106DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB1106DDEngine;
Procedure UnRegisterMariaDB1106DDEngine;

implementation

uses MariaDB1106conn;

Procedure RegisterMariaDB1106DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB1106DDEngine);
end;

Procedure UnRegisterMariaDB1106DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB1106DDEngine);
end;

{ TSQLDBMariaDB1106DDEngine }

function TSQLDBMariaDB1106DDEngine.CreateConnection(AConnectString: String): TSQLConnection;
begin
  Result:=MariaDB1106conn.TMariaDB1106Connection.Create(Self);
end;

class function TSQLDBMariaDB1106DDEngine.Description: string;
begin
  Result:='MariaDB 11.06 connection using SQLDB';
end;

class function TSQLDBMariaDB1106DDEngine.DBType: String;
begin
  Result:='MariaDB 11.06';
end;

end.

