{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 11.08 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddMariaDB1108;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB1108DDEngine }

  TSQLDBMariaDB1108DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB1108DDEngine;
Procedure UnRegisterMariaDB1108DDEngine;

implementation

uses MariaDB1108conn;

Procedure RegisterMariaDB1108DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB1108DDEngine);
end;

Procedure UnRegisterMariaDB1108DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB1108DDEngine);
end;

{ TSQLDBMariaDB1108DDEngine }

function TSQLDBMariaDB1108DDEngine.CreateConnection(AConnectString: String): TSQLConnection;
begin
  Result:=MariaDB1108conn.TMariaDB1108Connection.Create(Self);
end;

class function TSQLDBMariaDB1108DDEngine.Description: string;
begin
  Result:='MariaDB 11.08 connection using SQLDB';
end;

class function TSQLDBMariaDB1108DDEngine.DBType: String;
begin
  Result:='MariaDB 11.08';
end;

end.

