{**********************************************************************
                PilotLogic Software House
  
    FPC Package fcl-db

    MariaDB 5.5 Data Dictionary Engine Implementation.
    
    ct9999
 **********************************************************************}
  
unit fpddmariadb55;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
  
Type
  { TSQLDBMariaDB55DDEngine }

  TSQLDBMariaDB55DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure RegisterMariaDB55DDEngine;
Procedure UnRegisterMariaDB55DDEngine;

implementation

uses mariadb55conn;

Procedure RegisterMariaDB55DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBMariaDB55DDEngine);
end;

Procedure UnRegisterMariaDB55DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBMariaDB55DDEngine);
end;

{ TSQLDBMariaDB55DDEngine }

function TSQLDBMariaDB55DDEngine.CreateConnection(AConnectString: String
  ): TSQLConnection;
begin
  Result:=MariaDB55conn.TMariaDB55Connection.Create(Self);
end;

class function TSQLDBMariaDB55DDEngine.Description: string;
begin
  Result:='MariaDB 5.5 connection using SQLDB';
end;

class function TSQLDBMariaDB55DDEngine.DBType: String;
begin
  Result:='MariaDB 5.5';
end;

end.

