{
    This file is part of the Free Pascal run time library.
    Copyright (c) 2007 by Michael Van Canneyt, member of the
    Free Pascal development team

    MySQL 8.2 Data Dictionary Engine Implementation.

    See the file COPYING.FPC, included in this distribution,
    for details about the copyright.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 **********************************************************************}
{$IFNDEF FPC_DOTTEDUNITS}
unit fpddmysql82;
{$ENDIF FPC_DOTTEDUNITS}

{$mode objfpc}{$H+}

interface

{$IFDEF FPC_DOTTEDUNITS}
uses
  System.Classes, System.SysUtils, Data.Sqldb, Data.Dict.Base, Data.Dict.Sqldb;
{$ELSE FPC_DOTTEDUNITS}
uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
{$ENDIF FPC_DOTTEDUNITS}
  
Type
  { TSQLDBmysql82DDEngine }

  TSQLDBmysql82DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure Registermysql82DDEngine;
Procedure UnRegistermysql82DDEngine;

implementation

{$IFDEF FPC_DOTTEDUNITS}
uses Data.SqlDb.mysql82;
{$ELSE FPC_DOTTEDUNITS}
uses mysql82conn;
{$ENDIF FPC_DOTTEDUNITS}

Procedure Registermysql82DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBmysql82DDEngine);
end;

Procedure UnRegistermysql82DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBmysql82DDEngine);
end;

{ TSQLDBmysql82DDEngine }

function TSQLDBmysql82DDEngine.CreateConnection(AConnectString: String
  ): TSQLConnection;
begin
  Result:={$IFDEF FPC_DOTTEDUNITS}Data.SqlDb.mysql82{$ELSE}mysql82conn{$ENDIF}.Tmysql82Connection.Create(Self);
end;

class function TSQLDBmysql82DDEngine.Description: string;
begin
  Result:='Mysql 8.2 connection using SQLDB';
end;

class function TSQLDBmysql82DDEngine.DBType: String;
begin
  Result:='MySQL 8.2';
end;

end.

