{
    This file is part of the Free Pascal run time library.
    Copyright (c) 2007 by Michael Van Canneyt, member of the
    Free Pascal development team

    MySQL 9.0 Data Dictionary Engine Implementation.

    See the file COPYING.FPC, included in this distribution,
    for details about the copyright.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 **********************************************************************}
{$IFNDEF FPC_DOTTEDUNITS}
unit fpddmysql90;
{$ENDIF FPC_DOTTEDUNITS}

{$mode objfpc}{$H+}

interface

{$IFDEF FPC_DOTTEDUNITS}
uses
  System.Classes, System.SysUtils, Data.Sqldb, Data.Dict.Base, Data.Dict.Sqldb;
{$ELSE FPC_DOTTEDUNITS}
uses
  Classes, SysUtils, sqldb, fpdatadict, fpddsqldb;
{$ENDIF FPC_DOTTEDUNITS}
  
Type
  { TSQLDBmysql90DDEngine }

  TSQLDBmysql90DDEngine = Class(TSQLDBDDEngine)
  Protected
    Function CreateConnection(AConnectString  : String) : TSQLConnection; override;
  Public
    Class function Description : string; override;
    Class function DBType : String; override;
  end;

Procedure Registermysql90DDEngine;
Procedure UnRegistermysql90DDEngine;

implementation

{$IFDEF FPC_DOTTEDUNITS}
uses Data.SqlDb.mysql90;
{$ELSE FPC_DOTTEDUNITS}
uses mysql90conn;
{$ENDIF FPC_DOTTEDUNITS}

Procedure Registermysql90DDEngine;

begin
  RegisterDictionaryEngine(TSQLDBmysql90DDEngine);
end;

Procedure UnRegistermysql90DDEngine;

begin
  UnRegisterDictionaryEngine(TSQLDBmysql90DDEngine);
end;

{ TSQLDBmysql90DDEngine }

function TSQLDBmysql90DDEngine.CreateConnection(AConnectString: String
  ): TSQLConnection;
begin
  Result:={$IFDEF FPC_DOTTEDUNITS}Data.SqlDb.mysql90{$ELSE}mysql90conn{$ENDIF}.Tmysql90Connection.Create(Self);
end;

class function TSQLDBmysql90DDEngine.Description: string;
begin
  Result:='Mysql 9.0 connection using SQLDB';
end;

class function TSQLDBmysql90DDEngine.DBType: String;
begin
  Result:='MySQL 9.0';
end;

end.

